//+------------------------------------------------------------------+
//|                                                       283776.mq4 |
//|                        Copyright 2018, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2018, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#include <Arrays\ArrayObj.mqh>

class Foo : public CObject{public:virtual int Type()const{return 0;}};
class Bar1 : public Foo    {public:virtual int Type()const{return 1;}};
class Bar2 : public Foo    {public:virtual int Type()const{return 2;}};
class Bar3 : public Foo    {public:virtual int Type()const{return 3;}};
class Bar4 : public Foo    {public:virtual int Type()const{return 4;}};
class Bar5 : public Foo    {public:virtual int Type()const{return 5;}};
class Bar6 : public Foo    {public:virtual int Type()const{return 6;}};
class Bar7 : public Foo    {public:virtual int Type()const{return 7;}};
class Bar8 : public Foo    {public:virtual int Type()const{return 8;}};
class Bar9 : public Foo    {public:virtual int Type()const{return 9;}};
class Bar10 : public Foo    {public:virtual int Type()const{return 10;}};
class Bar11 : public Foo    {public:virtual int Type()const{return 11;}};
class Bar12 : public Foo    {public:virtual int Type()const{return 12;}};
class Bar13 : public Foo    {public:virtual int Type()const{return 13;}};
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
//---

   int TEST_ITERS=100000;
   CArrayObj arr;
   arr.Add(new Foo);
   arr.Add(new Bar1);
   arr.Add(new Bar2);
   arr.Add(new Bar3);
   arr.Add(new Bar4);
   arr.Add(new Bar5);
   arr.Add(new Bar6);
   arr.Add(new Bar7);
   arr.Add(new Bar8);
   arr.Add(new Bar9);
   arr.Add(new Bar10);
   arr.Add(new Bar11);
   arr.Add(new Bar12);
   arr.Add(new Bar13);
   int total=arr.Total();
   string res_template="iterations(%d), sanity-check(%s): Method=%s, time=%d";
   ulong ms=GetTickCount();
   ulong count=0;
   for(int i=0; i<TEST_ITERS; i++)
      for(int j=0; j<total; j++)
        {
         if(arr.At(j).Type()==1)
            count++;
         else if(arr.At(j).Type()==2)
            count++;
         else if(arr.At(j).Type()==3)
            count++;
         else if(arr.At(j).Type()==4)
            count++;
         else if(arr.At(j).Type()==5)
            count++;
         else if(arr.At(j).Type()==6)
            count++;
         else if(arr.At(j).Type()==7)
            count++;
         else if(arr.At(j).Type()==8)
            count++;
         else if(arr.At(j).Type()==9)
            count++;
         else if(arr.At(j).Type()==10)
            count++;
         else if(arr.At(j).Type()==11)
            count++;
         else if(arr.At(j).Type()==12)
            count++;
         else if(arr.At(j).Type()==13)
            count++;
        }

   printf(res_template,
          TEST_ITERS,string(count==TEST_ITERS),
          "obj.Type()",GetTickCount()-ms
          );
   ms=GetTickCount();
   count=0;
   for(int i=0; i<TEST_ITERS; i++)
      for(int j=0; j<total; j++)
        {
         if(CheckPointer(dynamic_cast<Bar1*>(arr.At(j))))
            count++;
         if(CheckPointer(dynamic_cast<Bar2*>(arr.At(j))))
            count++;
         if(CheckPointer(dynamic_cast<Bar3*>(arr.At(j))))
            count++;
         if(CheckPointer(dynamic_cast<Bar4*>(arr.At(j))))
            count++;
         if(CheckPointer(dynamic_cast<Bar5*>(arr.At(j))))
            count++;
         if(CheckPointer(dynamic_cast<Bar6*>(arr.At(j))))
            count++;
         if(CheckPointer(dynamic_cast<Bar7*>(arr.At(j))))
            count++;
         if(CheckPointer(dynamic_cast<Bar8*>(arr.At(j))))
            count++;
         if(CheckPointer(dynamic_cast<Bar9*>(arr.At(j))))
            count++;
         if(CheckPointer(dynamic_cast<Bar10*>(arr.At(j))))
            count++;
         if(CheckPointer(dynamic_cast<Bar11*>(arr.At(j))))
            count++;
         if(CheckPointer(dynamic_cast<Bar12*>(arr.At(j))))
            count++;
         if(CheckPointer(dynamic_cast<Bar13*>(arr.At(j))))
            count++;
        }

   printf(res_template,
          TEST_ITERS,string(count==TEST_ITERS),
          "dynamic_cast<>",GetTickCount()-ms
          );
  }
//+------------------------------------------------------------------+
